/*
Copyright 2004 Cesar Tardaguila & Javier Tardaguila

This file is part of Drops.

Drops is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Srops is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Drops; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import Code.World.*

class Code.UI.DropsView
{
	private var viewMC			: MovieClip;
	private var infoPack		: MovieClip;
	
	private static var STAGE_SIZE: Number = 400;
	
	private var controllerVal	: DropsController;
	
	public function DropsView( viewMCParam: MovieClip )
	{
		viewMC = viewMCParam;
		
	}
	
	public function set controller( controllerParam: DropsController )
	{
		this.controllerVal = controllerParam;
	}
	
	public function timeHasChanged( param: Object )
	{
		this.viewMC.clockTF.text = param.timeToShow;
	}
	
	public function firstFeedback( param: Object  )
	{
		this.infoPack = param.timeline.attachMovie( "alert", "myAlert", param.timeline.getNextHighestDepth( ), { _x: STAGE_SIZE/2, _y: STAGE_SIZE/2 }  );
		
		infoPack.infoTF.text = "Start game?";
		infoPack.yesTF.text = "Yes";
		infoPack.noTF.text = "";
		
		var myView: DropsView = this;
		infoPack.btOK.onRelease = function( )
		{
			myView.alertClickHandler( );
		}
	}	
	
	public function timeIsOver( param: Object  )
	{
		this.infoPack = param.timeline.attachMovie( "alert", "myAlert", param.timeline.getNextHighestDepth( ), { _x: STAGE_SIZE/2, _y: STAGE_SIZE/2 }  );
		
		infoPack.infoTF.text = "Try again?";
		infoPack.yesTF.text = "Yes";
		infoPack.noTF.text = "No!";
		
		var myView: DropsView = this;
		infoPack.btOK.onRelease = function( )
		{
			myView.alertNewGameHandler( true );
		}
		
		infoPack.btCANCEL.onRelease = function( )
		{
			myView.alertNewGameHandler( false );
		}				
		
	}
	
	public function endOfGame( param: Object )
	{
		var feedBackText: String = param.victoryFlag ? "You Won! ": "You lost!";
		
		this.infoPack = param.timeline.attachMovie( "alert", "myAlert", param.timeline.getNextHighestDepth( ), { _x: STAGE_SIZE/2, _y: STAGE_SIZE/2 }  );
		
		infoPack.infoTF.text = feedBackText;
		infoPack.yesTF.text = "";
		infoPack.noTF.text = "";		
		
	}
	
	
	private function alertClickHandler( evt )
	{
			this.buttonOK( );
			this.infoPack.removeMovieClip( );
	}
	
	private function alertNewGameHandler( flag: Boolean )
	{
		if ( flag )
		{
			this.newGameOK( );
		}
		else
		{
			this.newGameCANCEL( );
		}		
		
		this.infoPack.removeMovieClip( );		
	}	
	
	public function buttonOK( )
	{
		this.controllerVal.runGame( );
	}
	
	public function newGameOK( )
	{
		this.controllerVal.newGame( );
	}
	
	public function newGameCANCEL( )
	{
		this.controllerVal.endGame( );
	}
}